'use strict';

var AST8 = require('@eslint-react/ast');
var eff = require('@eslint-react/eff');
var kit = require('@eslint-react/kit');
var shared = require('@eslint-react/shared');
var types = require('@typescript-eslint/types');
var VAR3 = require('@eslint-react/var');
var tsPattern = require('ts-pattern');
var birecord = require('birecord');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var AST8__namespace = /*#__PURE__*/_interopNamespace(AST8);
var VAR3__namespace = /*#__PURE__*/_interopNamespace(VAR3);
var birecord__default = /*#__PURE__*/_interopDefault(birecord);

// src/component/component-collector.ts

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/core.js
// @__NO_SIDE_EFFECTS__
function $constructor(name, initializer) {
  class _6 {
    constructor(def) {
      var _a;
      const th = this;
      _6.init(th, def);
      (_a = th._zod).deferred ?? (_a.deferred = []);
      for (const fn of th._zod.deferred) {
        fn();
      }
    }
    static init(inst, def) {
      var _a;
      inst._zod ?? (inst._zod = {});
      (_a = inst._zod).traits ?? (_a.traits = /* @__PURE__ */ new Set());
      inst._zod.traits.add(name);
      initializer(inst, def);
      for (const k in _6.prototype) {
        Object.defineProperty(inst, k, { value: _6.prototype[k].bind(inst) });
      }
      inst._zod.constr = _6;
      inst._zod.def = def;
    }
    static [Symbol.hasInstance](inst) {
      return inst?._zod?.traits?.has(name);
    }
  }
  Object.defineProperty(_6, "name", { value: name });
  return _6;
}
var $ZodAsyncError = class extends Error {
  constructor() {
    super(`Encountered Promise during synchronous parse. Use .parseAsync() instead.`);
  }
};
var globalConfig = {};
function config(config2) {
  return globalConfig;
}
function jsonStringifyReplacer(_6, value) {
  if (typeof value === "bigint")
    return value.toString();
  return value;
}
function cached(getter) {
  return {
    get value() {
      {
        const value = getter();
        Object.defineProperty(this, "value", { value });
        return value;
      }
    }
  };
}
function cleanRegex(source) {
  const start = source.startsWith("^") ? 1 : 0;
  const end = source.endsWith("$") ? source.length - 1 : source.length;
  return source.slice(start, end);
}
function defineLazy(object2, key, getter) {
  Object.defineProperty(object2, key, {
    get() {
      {
        const value = getter();
        object2[key] = value;
        return value;
      }
    },
    set(v) {
      Object.defineProperty(object2, key, {
        value: v
        // configurable: true,
      });
    },
    configurable: true
  });
}
function randomString(length = 10) {
  const chars = "abcdefghijklmnopqrstuvwxyz";
  let str = "";
  for (let i = 0; i < length; i++) {
    str += chars[Math.floor(Math.random() * chars.length)];
  }
  return str;
}
function esc(str) {
  return JSON.stringify(str);
}
function isObject(data) {
  return typeof data === "object" && data !== null;
}
var allowsEval = cached(() => {
  try {
    new Function("");
    return true;
  } catch (_6) {
    return false;
  }
});
function clone(inst, def) {
  return new inst._zod.constr(def);
}
function normalizeParams(_params) {
  const params = _params;
  if (!params)
    return {};
  if (typeof params === "string")
    return { error: () => params };
  if (params?.message !== void 0) {
    if (params?.error !== void 0)
      throw new Error("Cannot specify both `message` and `error` params");
    params.error = params.message;
  }
  delete params.message;
  if (typeof params.error === "string")
    return { ...params, error: () => params.error };
  return params;
}
function optionalObjectKeys(shape) {
  return Object.keys(shape).filter((k) => {
    return shape[k]._zod.qout === "true";
  });
}
function aborted(x, startIndex = 0) {
  for (let i = startIndex; i < x.issues.length; i++) {
    if (x.issues[i].continue !== true)
      return true;
  }
  return false;
}
function prefixIssues(path, issues) {
  return issues.map((iss) => {
    var _a;
    (_a = iss).path ?? (_a.path = []);
    iss.path.unshift(path);
    return iss;
  });
}
function unwrapMessage(message) {
  return typeof message === "string" ? message : message?.message;
}
function finalizeIssue(iss, ctx, config2) {
  const full = { ...iss, path: iss.path ?? [] };
  if (!iss.message) {
    const message = unwrapMessage(iss.inst?._zod.def?.error?.(iss)) ?? unwrapMessage(ctx?.error?.(iss)) ?? unwrapMessage(config2.customError?.(iss)) ?? unwrapMessage(config2.localeError?.(iss)) ?? "Invalid input";
    full.message = message;
  }
  delete full.inst;
  delete full.continue;
  if (!ctx?.reportInput) {
    delete full.input;
  }
  return full;
}

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/errors.js
var ZOD_ERROR = Symbol.for("{{zod.error}}");
var $ZodError = class {
  get message() {
    return JSON.stringify(this.issues, jsonStringifyReplacer, 2);
  }
  constructor(issues) {
    Object.defineProperty(this, "_tag", { value: ZOD_ERROR, enumerable: false });
    Object.defineProperty(this, "name", { value: "$ZodError", enumerable: false });
    this.issues = issues;
  }
  // @ts-ignore
  static [Symbol.hasInstance](inst) {
    return inst?._tag === ZOD_ERROR;
  }
};

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/parse.js
function _parse(schema, value, _ctx) {
  const ctx = _ctx ? { ..._ctx, async: false } : { async: false };
  const result = schema._zod.run({ value, issues: [] }, ctx);
  if (result instanceof Promise) {
    throw new $ZodAsyncError();
  }
  if (result.issues.length) {
    throw new (this?.Error ?? $ZodError)(result.issues.map((iss) => finalizeIssue(iss, ctx, config())));
  }
  return result.value;
}
function _safeParse(schema, value, _ctx) {
  const ctx = _ctx ? { ..._ctx, async: false } : { async: false };
  const result = schema._zod.run({ value, issues: [] }, ctx);
  if (result instanceof Promise) {
    throw new $ZodAsyncError();
  }
  return result.issues.length ? {
    success: false,
    error: new (this?.Error ?? $ZodError)(result.issues.map((iss) => finalizeIssue(iss, ctx, config())))
  } : { success: true, data: result.value };
}
async function _parseAsync(schema, value, _ctx) {
  const ctx = _ctx ? { ..._ctx, async: true } : { async: true };
  let result = schema._zod.run({ value, issues: [] }, ctx);
  if (result instanceof Promise)
    result = await result;
  if (result.issues.length) {
    throw new (this?.Error ?? $ZodError)(result.issues.map((iss) => finalizeIssue(iss, ctx, config())));
  }
  return result.value;
}
async function _safeParseAsync(schema, value, _ctx) {
  const ctx = _ctx ? { ..._ctx, async: true } : { async: true };
  let result = schema._zod.run({ value, issues: [] }, ctx);
  if (result instanceof Promise)
    result = await result;
  if (result.issues.length) {
    return {
      success: false,
      error: new (this?.Error ?? $ZodError)(result.issues.map((iss) => finalizeIssue(iss, ctx, config())))
    };
  }
  return { success: true, data: result.value };
}
var string = (params) => {
  const regex = params ? `[\\s\\S]{${params?.minimum ?? 0},${params?.maximum ?? ""}}` : `[\\s\\S]*`;
  return new RegExp(`^${regex}$`);
};
var boolean = /true|false/i;

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/doc.js
var Doc = class {
  constructor(args) {
    this.content = [];
    this.indent = 0;
    this.args = args;
  }
  indented(fn) {
    this.indent += 1;
    fn(this);
    this.indent -= 1;
  }
  write(arg) {
    if (typeof arg === "function") {
      arg(this, { execution: "sync" });
      arg(this, { execution: "async" });
      return;
    }
    const content = arg;
    const lines = content.split("\n").filter((x) => x);
    const minIndent = Math.min(...lines.map((x) => x.length - x.trimStart().length));
    const dedented = lines.map((x) => x.slice(minIndent)).map((x) => " ".repeat(this.indent * 2) + x);
    for (const line of dedented) {
      this.content.push(line);
    }
  }
  compile() {
    const lines = [...this.content.map((x) => `  ${x}`)];
    return new Function(...this.args, lines.join("\n"));
  }
};

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/schemas.js
var $ZodType = /* @__PURE__ */ $constructor("$ZodType", (inst, def) => {
  var _a;
  inst ?? (inst = {});
  inst._zod.id = def.type + "_" + randomString(10);
  inst._zod.def = def;
  inst._zod.computed = inst._zod.computed || {};
  const checks = [...inst._zod.def.checks ?? []];
  def.type;
  if (inst._zod.traits.has("$ZodCheck")) {
    checks.unshift(inst);
  }
  for (const ch of checks) {
    ch._zod.onattach?.(inst);
  }
  if (checks.length === 0) {
    (_a = inst._zod).deferred ?? (_a.deferred = []);
    inst._zod.deferred?.push(() => {
      inst._zod.run = inst._zod.parse;
    });
  } else {
    const runChecks = (payload, checks2, ctx) => {
      let isAborted = aborted(payload);
      let asyncResult;
      for (const ch of checks2) {
        if (ch._zod.when) {
          const shouldRun = ch._zod.when(payload);
          if (!shouldRun)
            continue;
        } else {
          if (isAborted) {
            continue;
          }
        }
        const currLen = payload.issues.length;
        const _6 = ch._zod.check(payload);
        if (_6 instanceof Promise && ctx?.async === false) {
          throw new $ZodAsyncError();
        }
        if (asyncResult || _6 instanceof Promise) {
          asyncResult = asyncResult ?? Promise.resolve();
          asyncResult.then(async () => {
            await _6;
            const nextLen = payload.issues.length;
            if (nextLen === currLen)
              return;
            if (!isAborted)
              isAborted = aborted(payload, currLen);
          });
        } else {
          const nextLen = payload.issues.length;
          if (nextLen === currLen)
            continue;
          if (!isAborted)
            isAborted = aborted(payload, currLen);
        }
      }
      if (asyncResult) {
        return asyncResult.then(() => {
          return payload;
        });
      }
      return payload;
    };
    inst._zod.run = (payload, ctx) => {
      const result = inst._zod.parse(payload, ctx);
      if (result instanceof Promise) {
        if (ctx.async === false)
          throw new $ZodAsyncError();
        return result.then((result2) => runChecks(result2, checks, ctx));
      }
      return runChecks(result, checks, ctx);
    };
  }
  defineLazy(inst, "~standard", () => ({
    validate: (value) => {
      const result = inst._zod.run({ value, issues: [] }, {});
      if (result instanceof Promise) {
        return result.then(({ issues, value: value2 }) => {
          if (issues.length === 0)
            return { value: value2 };
          return { issues };
        });
      }
      if (result.issues.length === 0)
        return { value: result.value };
      return { issues: result.issues };
    },
    vendor: "zod",
    version: 1
  }));
});
var $ZodString = /* @__PURE__ */ $constructor("$ZodString", (inst, def) => {
  $ZodType.init(inst, def);
  inst._zod.pattern = inst?._zod.computed?.pattern ?? string(inst._zod.computed);
  inst._zod.parse = (payload, _6) => {
    if (def.coerce)
      try {
        payload.value = String(payload.value);
      } catch (_7) {
      }
    if (typeof payload.value === "string")
      return payload;
    payload.issues.push({
      expected: "string",
      code: "invalid_type",
      input: payload.value,
      inst
    });
    return payload;
  };
});
var $ZodBoolean = /* @__PURE__ */ $constructor("$ZodBoolean", (inst, def) => {
  $ZodType.init(inst, def);
  inst._zod.pattern = boolean;
  inst._zod.parse = (payload, _ctx) => {
    if (def.coerce)
      try {
        payload.value = Boolean(payload.value);
      } catch (_6) {
      }
    const input = payload.value;
    if (typeof input === "boolean")
      return payload;
    payload.issues.push({
      expected: "boolean",
      code: "invalid_type",
      input,
      inst
    });
    return payload;
  };
});
function handleArrayResult(result, final, index) {
  if (result.issues.length) {
    final.issues.push(...prefixIssues(index, result.issues));
  }
  final.value[index] = result.value;
}
var $ZodArray = /* @__PURE__ */ $constructor("$ZodArray", (inst, def) => {
  $ZodType.init(inst, def);
  inst._zod.parse = (payload, ctx) => {
    const input = payload.value;
    if (!Array.isArray(input)) {
      payload.issues.push({
        expected: "array",
        code: "invalid_type",
        input,
        inst
      });
      return payload;
    }
    payload.value = Array(input.length);
    const proms = [];
    for (let i = 0; i < input.length; i++) {
      const item = input[i];
      const result = def.element._zod.run({
        value: item,
        issues: []
      }, ctx);
      if (result instanceof Promise) {
        proms.push(result.then((result2) => handleArrayResult(result2, payload, i)));
      } else {
        handleArrayResult(result, payload, i);
      }
    }
    if (proms.length) {
      return Promise.all(proms).then(() => payload);
    }
    return payload;
  };
});
function handleObjectResult(result, final, key) {
  if (result.issues.length) {
    final.issues.push(...prefixIssues(key, result.issues));
  } else {
    final.value[key] = result.value;
  }
}
function handleOptionalObjectResult(result, final, key, input) {
  if (result.issues.length) {
    if (input[key] === void 0) {
      if (key in input) {
        final.value[key] = void 0;
      }
    } else {
      final.issues.push(...prefixIssues(key, result.issues));
    }
  } else if (result.value === void 0) {
    if (key in input)
      final.value[key] = void 0;
  } else {
    final.value[key] = result.value;
  }
}
var $ZodObjectLike = /* @__PURE__ */ $constructor("$ZodObjectLike", (inst, def) => {
  $ZodType.init(inst, def);
  defineLazy(inst._zod, "shape", () => def.shape);
  const _normalized = cached(() => {
    const keys = Object.keys(def.shape);
    return {
      shape: def.shape,
      keys,
      keySet: new Set(keys),
      numKeys: keys.length,
      optionalKeys: new Set(def.optional)
    };
  });
  defineLazy(inst._zod, "disc", () => {
    const shape = def.shape;
    const discMap = /* @__PURE__ */ new Map();
    let hasDisc = false;
    for (const key in shape) {
      const field = shape[key]._zod;
      if (field.values || field.disc) {
        hasDisc = true;
        const o = {
          values: new Set(field.values ?? []),
          maps: field.disc ? [field.disc] : []
        };
        discMap.set(key, o);
      }
    }
    if (!hasDisc)
      return void 0;
    return discMap;
  });
  const generateFastpass = (shape) => {
    const doc = new Doc(["shape", "payload", "ctx"]);
    const { keys, optionalKeys } = _normalized.value;
    const parseStr = (key) => {
      const k = esc(key);
      return `shape[${k}]._zod.run({ value: input[${k}], issues: [] }, ctx)`;
    };
    doc.write(`const input = payload.value;`);
    const ids = {};
    for (const key of keys) {
      ids[key] = randomString(15);
    }
    for (const key of keys) {
      if (optionalKeys.has(key))
        continue;
      const id = ids[key];
      doc.write(`const ${id} = ${parseStr(key)};`);
      doc.write(`
          if (${id}.issues.length) payload.issues = payload.issues.concat(${id}.issues.map(iss => ({
            ...iss,
            path: iss.path ? [${esc(key)}, ...iss.path] : [${esc(key)}]
          })));`);
    }
    doc.write(`payload.value = {`);
    doc.indented(() => {
      for (const key of keys) {
        if (optionalKeys.has(key))
          continue;
        const id = ids[key];
        doc.write(`  ${esc(key)}: ${id}.value,`);
      }
    });
    doc.write(`}`);
    for (const key of keys) {
      if (!optionalKeys.has(key))
        continue;
      const id = ids[key];
      doc.write(`const ${id} = ${parseStr(key)};`);
      const k = esc(key);
      doc.write(`
        if (${id}.issues.length) {
          if (input[${k}] === undefined) {
            if (${k} in input) {
              payload.value[${k}] = undefined;
            }
          } else {
            payload.issues = payload.issues.concat(
              ${id}.issues.map((iss) => ({
                ...iss,
                path: iss.path ? [${k}, ...iss.path] : [${k}],
              }))
            );
          }
        } else if (${id}.value === undefined) {
          if (${k} in input) payload.value[${k}] = undefined;
        } else {
          payload.value[${k}] = ${id}.value;
        }  
        `);
    }
    doc.write(`return payload;`);
    const fn = doc.compile();
    return (payload, ctx) => fn(shape, payload, ctx);
  };
  let fastpass;
  const fastEnabled = allowsEval.value;
  const isObject2 = isObject;
  const { catchall } = def;
  inst._zod.parse = (payload, ctx) => {
    const input = payload.value;
    if (!isObject2(input)) {
      payload.issues.push({
        expected: "object",
        code: "invalid_type",
        input,
        inst
      });
      return payload;
    }
    const proms = [];
    if (fastEnabled && ctx?.async === false && ctx.noPrecompilation !== true) {
      if (!fastpass)
        fastpass = generateFastpass(def.shape);
      payload = fastpass(payload, ctx);
    } else {
      payload.value = {};
      const { keys, shape, optionalKeys } = _normalized.value;
      for (const key of keys) {
        const valueSchema = shape[key];
        const r = valueSchema._zod.run({ value: input[key], issues: [] }, ctx);
        const isOptional = optionalKeys.has(key);
        if (r instanceof Promise) {
          proms.push(r.then((r2) => isOptional ? handleOptionalObjectResult(r2, payload, key, input) : handleObjectResult(r2, payload, key)));
        } else {
          if (isOptional) {
            handleOptionalObjectResult(r, payload, key, input);
          } else {
            handleObjectResult(r, payload, key);
          }
        }
      }
    }
    if (!catchall) {
      return proms.length ? Promise.all(proms).then(() => payload) : payload;
    }
    const unrecognized = [];
    for (const key of Object.keys(input)) {
      if (_normalized.value.keySet.has(key))
        continue;
      if (catchall._zod.def.type === "never") {
        unrecognized.push(key);
        continue;
      }
      const r = catchall._zod.run({ value: input[key], issues: [] }, ctx);
      if (r instanceof Promise) {
        proms.push(r.then((r2) => handleObjectResult(r2, payload, key)));
      } else {
        handleObjectResult(r, payload, key);
      }
    }
    if (unrecognized.length) {
      payload.issues.push({
        code: "unrecognized_keys",
        keys: unrecognized,
        input,
        inst
      });
    }
    if (!proms.length)
      return payload;
    return Promise.all(proms).then(() => {
      return payload;
    });
  };
});
var $ZodObject = /* @__PURE__ */ $constructor("$ZodObject", (inst, def) => {
  $ZodObjectLike.init(inst, def);
});
var $ZodOptional = /* @__PURE__ */ $constructor("$ZodOptional", (inst, def) => {
  $ZodType.init(inst, def);
  inst._zod.qout = "true";
  if (def.innerType._zod.values)
    inst._zod.values = /* @__PURE__ */ new Set([...def.innerType._zod.values, void 0]);
  const pattern = def.innerType._zod.pattern;
  if (pattern)
    inst._zod.pattern = new RegExp(`^(${cleanRegex(pattern.source)})?$`);
  inst._zod.parse = (payload, ctx) => {
    if (payload.value === void 0) {
      return payload;
    }
    return def.innerType._zod.run(payload, ctx);
  };
});

// ../../node_modules/.pnpm/@zod+core@0.1.0/node_modules/@zod/core/dist/esm/api.js
function _string(Class, params) {
  return new Class({
    type: "string",
    ...normalizeParams(params)
  });
}
function _boolean(Class, params) {
  return new Class({
    type: "boolean",
    ...normalizeParams(params)
  });
}

// ../../node_modules/.pnpm/@zod+mini@4.0.0-beta.0/node_modules/@zod/mini/dist/esm/parse.js
var parse2 = /* @__PURE__ */ _parse.bind({ Error: $ZodError });
var safeParse = /* @__PURE__ */ _safeParse.bind({ Error: $ZodError });
var parseAsync2 = /* @__PURE__ */ _parseAsync.bind({ Error: $ZodError });
var safeParseAsync = /* @__PURE__ */ _safeParseAsync.bind({
  Error: $ZodError
});

// ../../node_modules/.pnpm/@zod+mini@4.0.0-beta.0/node_modules/@zod/mini/dist/esm/schemas.js
var ZodMiniType = /* @__PURE__ */ $constructor("ZodMiniType", (inst, def) => {
  if (!inst._zod)
    throw new Error("Uninitialized schema in mixin ZodMiniType.");
  $ZodType.init(inst, def);
  inst.def = def;
  inst.parse = (data, params) => parse2(inst, data, params);
  inst.safeParse = (data, params) => safeParse(inst, data, params);
  inst.parseAsync = async (data, params) => parseAsync2(inst, data, params);
  inst.safeParseAsync = async (data, params) => safeParseAsync(inst, data, params);
  inst.check = (...checks) => {
    return inst.clone({
      ...def,
      checks: [
        ...def.checks ?? [],
        ...checks.map((ch) => typeof ch === "function" ? { _zod: { check: ch, def: { check: "custom" } } } : ch)
      ]
    });
  };
  inst.clone = (_def) => clone(inst, _def ?? def);
  inst.brand = () => inst;
  inst.register = (reg, meta) => {
    reg.add(inst, meta);
    return inst;
  };
});
var ZodMiniString = /* @__PURE__ */ $constructor("ZodMiniString", (inst, def) => {
  $ZodString.init(inst, def);
  ZodMiniType.init(inst, def);
});
function string2(params) {
  return _string(ZodMiniString, params);
}
var ZodMiniBoolean = /* @__PURE__ */ $constructor("ZodMiniBoolean", (inst, def) => {
  $ZodBoolean.init(inst, def);
  ZodMiniType.init(inst, def);
});
function boolean2(params) {
  return _boolean(ZodMiniBoolean, params);
}
var ZodMiniArray = /* @__PURE__ */ $constructor("ZodMiniArray", (inst, def) => {
  $ZodArray.init(inst, def);
  ZodMiniType.init(inst, def);
});
function array(element, params) {
  return new ZodMiniArray({
    type: "array",
    element,
    // get element() {
    //   return element;
    // },
    ...normalizeParams(params)
  });
}
var ZodMiniObject = /* @__PURE__ */ $constructor("ZodMiniObject", (inst, def) => {
  $ZodObject.init(inst, def);
  ZodMiniType.init(inst, def);
});
function object(shape, params) {
  const def = {
    type: "object",
    shape: shape ?? {},
    get optional() {
      return optionalObjectKeys(shape ?? {});
    },
    ...normalizeParams(params)
  };
  return new ZodMiniObject(def);
}
var ZodMiniOptional = /* @__PURE__ */ $constructor("ZodMiniOptional", (inst, def) => {
  $ZodOptional.init(inst, def);
  ZodMiniType.init(inst, def);
});
function optional(innerType, params) {
  return new ZodMiniOptional({
    type: "optional",
    innerType,
    ...normalizeParams(params)
  });
}

// ../shared/src/schemas.ts
var CustomComponentPropSchema = object({
  /**
   * The name of the prop in the user-defined component.
   * @example
   * "to"
   */
  name: string2(),
  /**
   * The name of the prop in the host component.
   * @example
   * "href"
   */
  as: optional(string2()),
  /**
   * Whether the prop is controlled or not in the user-defined component.
   * @internal
   * @example
   * `true`
   */
  controlled: optional(boolean2()),
  /**
   * The default value of the prop in the user-defined component.
   * @example
   * `"/"`
   */
  defaultValue: optional(string2())
});
var CustomComponentSchema = object({
  /**
   * The name of the user-defined component.
   * @example
   * "Link"
   */
  name: string2(),
  /**
   * The name of the host component that the user-defined component represents.
   * @example
   * "a"
   */
  as: optional(string2()),
  /**
   * Attributes mapping between the user-defined component and the host component.
   * @example
   * `Link` component has a `to` attribute that represents the `href` attribute in the built-in `a` element with a default value of `"/"`.
   */
  attributes: optional(array(CustomComponentPropSchema)),
  /**
   * The ESQuery selector to select the component precisely.
   * @internal
   * @example
   * `JSXElement:has(JSXAttribute[name.name='component'][value.value='a'])`
   */
  selector: optional(string2())
});
var CustomHooksSchema = object({
  use: optional(array(string2())),
  useActionState: optional(array(string2())),
  useCallback: optional(array(string2())),
  useContext: optional(array(string2())),
  useDebugValue: optional(array(string2())),
  useDeferredValue: optional(array(string2())),
  useEffect: optional(array(string2())),
  useFormStatus: optional(array(string2())),
  useId: optional(array(string2())),
  useImperativeHandle: optional(array(string2())),
  useInsertionEffect: optional(array(string2())),
  useLayoutEffect: optional(array(string2())),
  useMemo: optional(array(string2())),
  useOptimistic: optional(array(string2())),
  useReducer: optional(array(string2())),
  useRef: optional(array(string2())),
  useState: optional(array(string2())),
  useSyncExternalStore: optional(array(string2())),
  useTransition: optional(array(string2()))
});
var ESLintReactSettingsSchema = object({
  /**
   * The source where React is imported from.
   * @description This allows to specify a custom import location for React when not using the official distribution.
   * @default `"react"`
   * @example `"@pika/react"`
   */
  importSource: optional(string2()),
  /**
   * The identifier that's used for JSX Element creation.
   * @default `"createElement"`
   * @deprecated
   */
  jsxPragma: optional(string2()),
  /**
   * The identifier that's used for JSX fragment elements.
   * @description This should not be a member expression (i.e. use "Fragment" instead of "React.Fragment").
   * @default `"Fragment"`
   * @deprecated
   */
  jsxPragmaFrag: optional(string2()),
  /**
   * The name of the prop that is used for polymorphic components.
   * @description This is used to determine the type of the component.
   * @example `"as"`
   */
  polymorphicPropName: optional(string2()),
  /**
   * @internal
   */
  strict: optional(boolean2()),
  /**
   * Check both the shape and the import to determine if an API is from React.
   * @description This can prevent false positives when using a irrelevant third-party library that has similar APIs to React.
   * @default `true`
   */
  skipImportCheck: optional(boolean2()),
  /**
   * React version to use, "detect" means auto detect React version from the project's dependencies.
   * If `importSource` is specified, an equivalent version of React should be provided here.
   * @example `"18.3.1"`
   * @default `"detect"`
   */
  version: optional(string2()),
  /**
   * A object to define additional hooks that are equivalent to the built-in React Hooks.
   * @description ESLint React will recognize these aliases as equivalent to the built-in hooks in all its rules.
   * @example `{ useEffect: ["useIsomorphicLayoutEffect"] }`
   */
  additionalHooks: optional(CustomHooksSchema),
  /**
   * An array of user-defined components
   * @description This is used to inform the ESLint React plugins how to treat these components during checks.
   * @example `[{ name: "Link", as: "a", attributes: [{ name: "to", as: "href" }, { name: "rel", defaultValue: "noopener noreferrer" }] }]`
   */
  additionalComponents: optional(array(CustomComponentSchema))
});
optional(
  object({
    "react-x": optional(ESLintReactSettingsSchema),
    /** @deprecated Use `react-x` instead */
    reactOptions: optional(ESLintReactSettingsSchema)
  }),
  {}
);
var DEFAULT_ESLINT_REACT_SETTINGS = {
  ...parse2(ESLintReactSettingsSchema, {}),
  importSource: "react"};
function getInstanceId(node, prev) {
  switch (true) {
    case (node.type === types.AST_NODE_TYPES.VariableDeclarator && node.init === prev):
      return node.id;
    case (node.type === types.AST_NODE_TYPES.AssignmentExpression && node.right === prev):
      return node.left;
    case (node.type === types.AST_NODE_TYPES.PropertyDefinition && node.value === prev):
      return node.key;
    case (node.type === types.AST_NODE_TYPES.BlockStatement || node.type === types.AST_NODE_TYPES.Program || node.parent === node):
      return eff._;
    default:
      return getInstanceId(node.parent, node);
  }
}
function getRequireExpressionArguments(node) {
  return tsPattern.match(node).with({ type: types.AST_NODE_TYPES.CallExpression, arguments: tsPattern.P.select(), callee: { type: types.AST_NODE_TYPES.Identifier, name: "require" } }, eff.identity).with({ type: types.AST_NODE_TYPES.MemberExpression, object: tsPattern.P.select() }, getRequireExpressionArguments).otherwise(() => null);
}
function isInitializedFromReact(name, importSource, initialScope) {
  if (name.toLowerCase() === "react") return true;
  const latestDef = VAR3__namespace.findVariable(name, initialScope)?.defs.at(-1);
  if (latestDef == null) return false;
  const { node, parent } = latestDef;
  if (node.type === types.AST_NODE_TYPES.VariableDeclarator && node.init != null) {
    const { init } = node;
    if (init.type === types.AST_NODE_TYPES.MemberExpression && init.object.type === types.AST_NODE_TYPES.Identifier) {
      return isInitializedFromReact(init.object.name, importSource, initialScope);
    }
    if (init.type === types.AST_NODE_TYPES.Identifier) {
      return isInitializedFromReact(init.name, importSource, initialScope);
    }
    const args = getRequireExpressionArguments(init);
    const arg0 = args?.[0];
    if (arg0 == null || !AST8__namespace.isLiteral(arg0, "string")) {
      return false;
    }
    return arg0.value === importSource || arg0.value.startsWith(`${importSource}/`);
  }
  return parent?.type === types.AST_NODE_TYPES.ImportDeclaration && parent.source.value === importSource;
}

// src/utils/is-from-react.ts
var defaultImportSource = shared.DEFAULT_ESLINT_REACT_SETTINGS.importSource;
function isFromReactLoose(node, name) {
  switch (node?.type) {
    case types.AST_NODE_TYPES.Identifier:
      return node.name === name;
    case types.AST_NODE_TYPES.MemberExpression:
      return node.object.type === types.AST_NODE_TYPES.Identifier && node.property.type === types.AST_NODE_TYPES.Identifier && node.property.name === name;
    default:
      return false;
  }
}
function isFromReactStrict(node, name, importSource, initialScope) {
  switch (node?.type) {
    case types.AST_NODE_TYPES.Identifier:
      return node.name === name && isInitializedFromReact(name, importSource, initialScope);
    case types.AST_NODE_TYPES.MemberExpression:
      return node.object.type === types.AST_NODE_TYPES.Identifier && node.property.type === types.AST_NODE_TYPES.Identifier && node.property.name === name && isInitializedFromReact(node.object.name, importSource, initialScope);
    default:
      return false;
  }
}
function isFromReact(name) {
  return eff.dual(2, (context, node) => {
    if (node == null) return false;
    const { importSource = defaultImportSource, skipImportCheck = true } = shared.unsafeDecodeSettings(context.settings);
    if (skipImportCheck) return isFromReactLoose(node, name);
    return isFromReactStrict(node, name, importSource, context.sourceCode.getScope(node));
  });
}
function isFromReactObject(objectName, propertyName) {
  return eff.dual(2, (context, node) => {
    if (node?.type !== types.AST_NODE_TYPES.MemberExpression) return false;
    const { importSource = defaultImportSource, skipImportCheck = true } = shared.unsafeDecodeSettings(context.settings);
    const { object: object2, property } = node;
    if (skipImportCheck) return isFromReactLoose(object2, objectName) && isFromReactLoose(property, propertyName);
    return isFromReactStrict(
      object2,
      objectName,
      importSource,
      context.sourceCode.getScope(object2)
    ) && isFromReactLoose(property, propertyName);
  });
}
function isCallFromReact(name) {
  return eff.dual(2, (context, node) => {
    if (node.type !== types.AST_NODE_TYPES.CallExpression) return false;
    return isFromReact(name)(context, node.callee);
  });
}
function isCallFromReactObject(objectName, propertyName) {
  return eff.dual(2, (context, node) => {
    if (node.type !== types.AST_NODE_TYPES.CallExpression) return false;
    return isFromReactObject(objectName, propertyName)(context, node.callee);
  });
}
function isInstanceIdEqual(context, a, b) {
  return AST8__namespace.isNodeEqual(a, b) || VAR3__namespace.isNodeValueEqual(a, b, [
    context.sourceCode.getScope(a),
    context.sourceCode.getScope(b)
  ]);
}

// src/utils/is-react-api.ts
function isReactAPI(arg0, arg1) {
  return arg1 == null ? isFromReact(arg0) : isFromReactObject(arg0, arg1);
}
function isReactAPICall(arg0, arg1) {
  return arg1 == null ? isCallFromReact(arg0) : isCallFromReactObject(arg0, arg1);
}
var isCaptureOwnerStack = isReactAPI("captureOwnerStack");
var isChildrenCount = isReactAPI("Children", "count");
var isChildrenForEach = isReactAPI("Children", "forEach");
var isChildrenMap = isReactAPI("Children", "map");
var isChildrenOnly = isReactAPI("Children", "only");
var isChildrenToArray = isReactAPI("Children", "toArray");
var isCloneElement = isReactAPI("cloneElement");
var isCreateContext = isReactAPI("createContext");
var isCreateElement = isReactAPI("createElement");
var isCreateRef = isReactAPI("createRef");
var isForwardRef = isReactAPI("forwardRef");
var isMemo = isReactAPI("memo");
var isLazy = isReactAPI("lazy");
var isCaptureOwnerStackCall = isReactAPICall("captureOwnerStack");
var isChildrenCountCall = isReactAPICall("Children", "count");
var isChildrenForEachCall = isReactAPICall("Children", "forEach");
var isChildrenMapCall = isReactAPICall("Children", "map");
var isChildrenOnlyCall = isReactAPICall("Children", "only");
var isChildrenToArrayCall = isReactAPICall("Children", "toArray");
var isCloneElementCall = isReactAPICall("cloneElement");
var isCreateContextCall = isReactAPICall("createContext");
var isCreateElementCall = isReactAPICall("createElement");
var isCreateRefCall = isReactAPICall("createRef");
var isForwardRefCall = isReactAPICall("forwardRef");
var isMemoCall = isReactAPICall("memo");
var isLazyCall = isReactAPICall("lazy");

// src/hook/hook-name.ts
function isReactHookName(name) {
  return name === "use" || /^use[A-Z0-9]/.test(name);
}

// src/hook/hook-is.ts
function isReactHook(node) {
  if (node == null) return false;
  const id = AST8__namespace.getFunctionIdentifier(node);
  return id?.name != null && isReactHookName(id.name);
}
function isReactHookCall(node) {
  if (node == null) return false;
  if (node.type !== types.AST_NODE_TYPES.CallExpression) {
    return false;
  }
  if (node.callee.type === types.AST_NODE_TYPES.Identifier) {
    return isReactHookName(node.callee.name);
  }
  if (node.callee.type === types.AST_NODE_TYPES.MemberExpression) {
    return node.callee.property.type === types.AST_NODE_TYPES.Identifier && isReactHookName(node.callee.property.name);
  }
  return false;
}
function isReactHookCallWithName(context, node) {
  if (node == null || node.type !== types.AST_NODE_TYPES.CallExpression) return eff.constFalse;
  const {
    importSource = DEFAULT_ESLINT_REACT_SETTINGS.importSource,
    skipImportCheck = true
  } = shared.unsafeDecodeSettings(context.settings);
  const initialScope = context.sourceCode.getScope(node);
  return (name) => {
    switch (true) {
      case (node.callee.type === types.AST_NODE_TYPES.Identifier && node.callee.name === name):
        return skipImportCheck || isInitializedFromReact(name, importSource, initialScope);
      case (node.callee.type === types.AST_NODE_TYPES.MemberExpression && node.callee.property.type === types.AST_NODE_TYPES.Identifier && node.callee.property.name === name && "name" in node.callee.object):
        return skipImportCheck || isInitializedFromReact(node.callee.object.name, importSource, initialScope);
      default:
        return false;
    }
  };
}
function isReactHookCallWithNameLoose(node) {
  if (node == null || node.type !== types.AST_NODE_TYPES.CallExpression) return eff.constFalse;
  return (name) => {
    switch (node.callee.type) {
      case types.AST_NODE_TYPES.Identifier:
        return node.callee.name === name;
      case types.AST_NODE_TYPES.MemberExpression:
        return node.callee.property.type === types.AST_NODE_TYPES.Identifier && node.callee.property.name === name;
      default:
        return false;
    }
  };
}
function isReactHookCallWithNameAlias(context, name, alias = []) {
  const {
    importSource = DEFAULT_ESLINT_REACT_SETTINGS.importSource,
    skipImportCheck = true
  } = shared.unsafeDecodeSettings(context.settings);
  return (node) => {
    const initialScope = context.sourceCode.getScope(node);
    switch (true) {
      case (node.callee.type === types.AST_NODE_TYPES.Identifier && node.callee.name === name):
        return skipImportCheck || isInitializedFromReact(name, importSource, initialScope);
      case (node.callee.type === types.AST_NODE_TYPES.MemberExpression && node.callee.property.type === types.AST_NODE_TYPES.Identifier && node.callee.property.name === name && "name" in node.callee.object):
        return skipImportCheck || isInitializedFromReact(node.callee.object.name, importSource, initialScope);
      default:
        return alias.some(isReactHookCallWithNameLoose(node));
    }
  };
}
function isUseEffectCallLoose(node) {
  if (node == null) return false;
  if (node.type !== types.AST_NODE_TYPES.CallExpression) {
    return false;
  }
  switch (node.callee.type) {
    case types.AST_NODE_TYPES.Identifier:
      return /^use\w*Effect$/u.test(node.callee.name);
    case types.AST_NODE_TYPES.MemberExpression:
      return node.callee.property.type === types.AST_NODE_TYPES.Identifier && /^use\w*Effect$/u.test(node.callee.property.name);
    default:
      return false;
  }
}
var isUseCall = eff.flip(isReactHookCallWithName)("use");
var isUseActionStateCall = eff.flip(isReactHookCallWithName)("useActionState");
var isUseCallbackCall = eff.flip(isReactHookCallWithName)("useCallback");
var isUseContextCall = eff.flip(isReactHookCallWithName)("useContext");
var isUseDebugValueCall = eff.flip(isReactHookCallWithName)("useDebugValue");
var isUseDeferredValueCall = eff.flip(isReactHookCallWithName)("useDeferredValue");
var isUseEffectCall = eff.flip(isReactHookCallWithName)("useEffect");
var isUseFormStatusCall = eff.flip(isReactHookCallWithName)("useFormStatus");
var isUseIdCall = eff.flip(isReactHookCallWithName)("useId");
var isUseImperativeHandleCall = eff.flip(isReactHookCallWithName)("useImperativeHandle");
var isUseInsertionEffectCall = eff.flip(isReactHookCallWithName)("useInsertionEffect");
var isUseLayoutEffectCall = eff.flip(isReactHookCallWithName)("useLayoutEffect");
var isUseMemoCall = eff.flip(isReactHookCallWithName)("useMemo");
var isUseOptimisticCall = eff.flip(isReactHookCallWithName)("useOptimistic");
var isUseReducerCall = eff.flip(isReactHookCallWithName)("useReducer");
var isUseRefCall = eff.flip(isReactHookCallWithName)("useRef");
var isUseStateCall = eff.flip(isReactHookCallWithName)("useState");
var isUseSyncExternalStoreCall = eff.flip(isReactHookCallWithName)("useSyncExternalStore");
var isUseTransitionCall = eff.flip(isReactHookCallWithName)("useTransition");

// src/hook/hook-collector.ts
function useHookCollector() {
  const hooks = /* @__PURE__ */ new Map();
  const functionEntries = [];
  const onFunctionEnter = (node) => {
    const id = AST8__namespace.getFunctionIdentifier(node);
    const key = shared.getId();
    const name = id?.name;
    if (name != null && isReactHookName(name)) {
      functionEntries.push({ key, node, isHook: true });
      hooks.set(key, {
        id,
        key,
        kind: "function",
        name,
        node,
        flag: 0n,
        hint: 0n,
        hookCalls: []
      });
      return;
    }
    functionEntries.push({ key, node, isHook: false });
  };
  const onFunctionExit = () => {
    functionEntries.pop();
  };
  const ctx = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    getAllHooks(node) {
      return hooks;
    }
  };
  const listeners = {
    ":function[type]": onFunctionEnter,
    ":function[type]:exit": onFunctionExit,
    "CallExpression[type]"(node) {
      if (!isReactHookCall(node)) {
        return;
      }
      const fEntry = functionEntries.at(-1);
      if (fEntry?.key == null) {
        return;
      }
      const hook = hooks.get(fEntry.key);
      if (hook == null) {
        return;
      }
      hook.hookCalls.push(node);
    }
  };
  return { ctx, listeners };
}
function isFunctionOfUseEffectSetup(node) {
  if (node == null) return false;
  return node.parent?.type === types.AST_NODE_TYPES.CallExpression && node.parent.callee !== node && node.parent.callee.type === types.AST_NODE_TYPES.Identifier && node.parent.arguments.at(0) === node && isUseEffectCallLoose(node.parent);
}
function isFunctionOfUseEffectCleanup(node) {
  if (node == null) return false;
  const pReturn = AST8__namespace.findParentNode(node, AST8__namespace.is(types.AST_NODE_TYPES.ReturnStatement));
  const pFaunction = AST8__namespace.findParentNode(node, AST8__namespace.isFunction);
  const pFunctionOfReturn = AST8__namespace.findParentNode(pReturn, AST8__namespace.isFunction);
  if (pFaunction !== pFunctionOfReturn) return false;
  return isFunctionOfUseEffectSetup(pFaunction);
}
function stringifyJsx(node) {
  switch (node.type) {
    case types.AST_NODE_TYPES.JSXIdentifier:
      return node.name;
    case types.AST_NODE_TYPES.JSXNamespacedName:
      return `${node.namespace.name}:${node.name.name}`;
    case types.AST_NODE_TYPES.JSXMemberExpression:
      return `${stringifyJsx(node.object)}.${stringifyJsx(node.property)}`;
    case types.AST_NODE_TYPES.JSXText:
      return node.value;
    case types.AST_NODE_TYPES.JSXOpeningElement:
      return `<${stringifyJsx(node.name)}>`;
    case types.AST_NODE_TYPES.JSXClosingElement:
      return `</${stringifyJsx(node.name)}>`;
    case types.AST_NODE_TYPES.JSXOpeningFragment:
      return "<>";
    case types.AST_NODE_TYPES.JSXClosingFragment:
      return "</>";
  }
}

// src/jsx/jsx-attribute-name.ts
function getAttributeName(context, node) {
  return stringifyJsx(node.name);
}

// src/jsx/jsx-attribute.ts
function getAttribute(context, name, attributes, initialScope) {
  return attributes.findLast((attr) => {
    if (attr.type === types.AST_NODE_TYPES.JSXAttribute) {
      return getAttributeName(context, attr) === name;
    }
    if (initialScope == null) return false;
    switch (attr.argument.type) {
      case types.AST_NODE_TYPES.Identifier: {
        const variable = VAR3__namespace.findVariable(attr.argument.name, initialScope);
        const variableNode = VAR3__namespace.getVariableInitNode(variable, 0);
        if (variableNode?.type === types.AST_NODE_TYPES.ObjectExpression) {
          return VAR3__namespace.findPropertyInProperties(name, variableNode.properties, initialScope) != null;
        }
        return false;
      }
      case types.AST_NODE_TYPES.ObjectExpression:
        return VAR3__namespace.findPropertyInProperties(name, attr.argument.properties, initialScope) != null;
    }
    return false;
  });
}
function getAttributeValue(context, node, name) {
  const initialScope = context.sourceCode.getScope(node);
  switch (node.type) {
    case types.AST_NODE_TYPES.JSXAttribute:
      if (node.value?.type === types.AST_NODE_TYPES.Literal) {
        return {
          kind: "some",
          node: node.value,
          initialScope,
          value: node.value.value
        };
      }
      if (node.value?.type === types.AST_NODE_TYPES.JSXExpressionContainer) {
        return VAR3__namespace.toStaticValue({
          kind: "lazy",
          node: node.value.expression,
          initialScope
        });
      }
      return { kind: "none", node, initialScope };
    case types.AST_NODE_TYPES.JSXSpreadAttribute: {
      const staticValue = VAR3__namespace.toStaticValue({
        kind: "lazy",
        node: node.argument,
        initialScope
      });
      if (staticValue.kind === "none") {
        return staticValue;
      }
      return tsPattern.match(staticValue.value).with({ [name]: tsPattern.P.select(tsPattern.P.any) }, (value) => ({
        kind: "some",
        node: node.argument,
        initialScope,
        value
      })).otherwise(() => ({ kind: "none", node, initialScope }));
    }
    default:
      return { kind: "none", node, initialScope };
  }
}

// src/jsx/jsx-detection-hint.ts
var JSXDetectionHint = {
  None: 0n,
  SkipUndefined: 1n << 0n,
  SkipNullLiteral: 1n << 1n,
  SkipBooleanLiteral: 1n << 2n,
  SkipStringLiteral: 1n << 3n,
  SkipNumberLiteral: 1n << 4n,
  SkipBigIntLiteral: 1n << 5n,
  SkipEmptyArray: 1n << 6n,
  SkipCreateElement: 1n << 7n,
  StrictArray: 1n << 8n,
  StrictLogical: 1n << 9n,
  StrictConditional: 1n << 10n
};
var DEFAULT_JSX_DETECTION_HINT = 0n | JSXDetectionHint.SkipUndefined | JSXDetectionHint.SkipBooleanLiteral;

// src/jsx/jsx-detection.ts
function isJsxText(node) {
  if (node == null) return false;
  return node.type === types.AST_NODE_TYPES.JSXText || node.type === types.AST_NODE_TYPES.Literal;
}
function isJsxLike(code, node, hint = DEFAULT_JSX_DETECTION_HINT) {
  if (node == null) return false;
  if (AST8__namespace.isJSX(node)) return true;
  switch (node.type) {
    case types.AST_NODE_TYPES.Literal: {
      switch (typeof node.value) {
        case "boolean":
          return !(hint & JSXDetectionHint.SkipBooleanLiteral);
        case "string":
          return !(hint & JSXDetectionHint.SkipStringLiteral);
        case "number":
          return !(hint & JSXDetectionHint.SkipNumberLiteral);
        case "bigint":
          return !(hint & JSXDetectionHint.SkipBigIntLiteral);
      }
      if (node.value == null) {
        return !(hint & JSXDetectionHint.SkipNullLiteral);
      }
      return false;
    }
    case types.AST_NODE_TYPES.TemplateLiteral: {
      return !(hint & JSXDetectionHint.SkipStringLiteral);
    }
    case types.AST_NODE_TYPES.ArrayExpression: {
      if (hint & JSXDetectionHint.StrictArray) {
        return node.elements.every((n) => isJsxLike(code, n, hint));
      }
      return node.elements.some((n) => isJsxLike(code, n, hint));
    }
    case types.AST_NODE_TYPES.LogicalExpression: {
      if (hint & JSXDetectionHint.StrictLogical) {
        return isJsxLike(code, node.left, hint) && isJsxLike(code, node.right, hint);
      }
      return isJsxLike(code, node.left, hint) || isJsxLike(code, node.right, hint);
    }
    case types.AST_NODE_TYPES.ConditionalExpression: {
      let leftHasJSX2 = function(node2) {
        if (Array.isArray(node2.consequent)) {
          if (node2.consequent.length === 0) {
            return !(hint & JSXDetectionHint.SkipEmptyArray);
          }
          if (hint & JSXDetectionHint.StrictArray) {
            return node2.consequent.every((n) => isJsxLike(code, n, hint));
          }
          return node2.consequent.some((n) => isJsxLike(code, n, hint));
        }
        return isJsxLike(code, node2.consequent, hint);
      }, rightHasJSX2 = function(node2) {
        return isJsxLike(code, node2.alternate, hint);
      };
      if (hint & JSXDetectionHint.StrictConditional) {
        return leftHasJSX2(node) && rightHasJSX2(node);
      }
      return leftHasJSX2(node) || rightHasJSX2(node);
    }
    case types.AST_NODE_TYPES.SequenceExpression: {
      const exp = node.expressions.at(-1);
      return isJsxLike(code, exp, hint);
    }
    case types.AST_NODE_TYPES.CallExpression: {
      if (hint & JSXDetectionHint.SkipCreateElement) {
        return false;
      }
      switch (node.callee.type) {
        case types.AST_NODE_TYPES.Identifier:
          return node.callee.name === "createElement";
        case types.AST_NODE_TYPES.MemberExpression:
          return node.callee.property.type === types.AST_NODE_TYPES.Identifier && node.callee.property.name === "createElement";
      }
      return false;
    }
    case types.AST_NODE_TYPES.Identifier: {
      const { name } = node;
      if (name === "undefined") {
        return !(hint & JSXDetectionHint.SkipUndefined);
      }
      if (AST8__namespace.isJSXTagNameExpression(node)) {
        return true;
      }
      const variable = VAR3__namespace.findVariable(name, code.getScope(node));
      const variableNode = variable && VAR3__namespace.getVariableInitNode(variable, 0);
      return !!variableNode && isJsxLike(code, variableNode, hint);
    }
  }
  return false;
}
function getElementType(context, node) {
  if (node.type === types.AST_NODE_TYPES.JSXFragment) {
    return "";
  }
  return stringifyJsx(node.openingElement.name);
}

// src/jsx/jsx-has.ts
function hasAttribute(context, name, attributes, initialScope) {
  return getAttribute(context, name, attributes, initialScope) != null;
}
function hasAnyAttribute(context, names, attributes, initialScope) {
  return names.some((n) => hasAttribute(context, n, attributes, initialScope));
}
function hasEveryAttribute(context, names, attributes, initialScope) {
  return names.every((n) => hasAttribute(context, n, attributes, initialScope));
}
function findParentAttribute(node, test = eff.constTrue) {
  const guard = (node2) => {
    return node2.type === types.AST_NODE_TYPES.JSXAttribute && test(node2);
  };
  return AST8__namespace.findParentNode(node, guard);
}
function isHostElement(context, node) {
  return node.type === types.AST_NODE_TYPES.JSXElement && node.openingElement.name.type === types.AST_NODE_TYPES.JSXIdentifier && /^[a-z]/u.test(node.openingElement.name.name);
}
function isKeyedElement(context, node, initialScope) {
  return node.type === types.AST_NODE_TYPES.JSXElement && hasAttribute(context, "key", node.openingElement.attributes, initialScope);
}
function isFragmentElement(context, node, allowJSXFragment = false) {
  if (node == null) return false;
  if (node.type !== types.AST_NODE_TYPES.JSXElement && node.type !== types.AST_NODE_TYPES.JSXFragment) return false;
  if (node.type === types.AST_NODE_TYPES.JSXFragment) return allowJSXFragment;
  return getElementType(context, node).split(".").at(-1) === "Fragment";
}

// src/component/component-detection-hint.ts
var ComponentDetectionHint = {
  /**
   * 1n << 0n - 1n << 63n are reserved for JSXDetectionHint
   */
  ...JSXDetectionHint,
  /**
   * Skip function component created by React.memo
   */
  SkipMemo: 1n << 64n,
  /**
   * Skip function component created by React.forwardRef
   */
  SkipForwardRef: 1n << 65n,
  /**
   * Skip function component defined as array map argument
   */
  SkipArrayMapArgument: 1n << 66n,
  /**
   * Skip function component defined on object method
   */
  SkipObjectMethod: 1n << 67n,
  /**
   * Skip function component defined on class method
   */
  SkipClassMethod: 1n << 68n,
  /**
   * Skip function component defined on class property
   */
  SkipClassProperty: 1n << 69n
};
var DEFAULT_COMPONENT_DETECTION_HINT = 0n | ComponentDetectionHint.SkipBooleanLiteral | ComponentDetectionHint.SkipEmptyArray | ComponentDetectionHint.SkipArrayMapArgument | ComponentDetectionHint.SkipNumberLiteral | ComponentDetectionHint.SkipStringLiteral | ComponentDetectionHint.SkipUndefined | ComponentDetectionHint.StrictArray | ComponentDetectionHint.StrictConditional | ComponentDetectionHint.StrictLogical;
function isClassComponent(node) {
  if ("superClass" in node && node.superClass != null) {
    const re = /^(?:Pure)?Component$/u;
    switch (true) {
      case node.superClass.type === types.AST_NODE_TYPES.Identifier:
        return re.test(node.superClass.name);
      case (node.superClass.type === types.AST_NODE_TYPES.MemberExpression && node.superClass.property.type === types.AST_NODE_TYPES.Identifier):
        return re.test(node.superClass.property.name);
    }
  }
  return false;
}
function isPureComponent(node) {
  if ("superClass" in node && node.superClass != null) {
    const re = /^PureComponent$/u;
    switch (true) {
      case node.superClass.type === types.AST_NODE_TYPES.Identifier:
        return re.test(node.superClass.name);
      case (node.superClass.type === types.AST_NODE_TYPES.MemberExpression && node.superClass.property.type === types.AST_NODE_TYPES.Identifier):
        return re.test(node.superClass.property.name);
    }
  }
  return false;
}
function isComponentDidCatch(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentDidCatch";
}
function isComponentDidMount(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentDidMount";
}
function isComponentDidUpdate(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentDidUpdate";
}
function isComponentWillMount(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentWillMount";
}
function isComponentWillReceiveProps(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentWillReceiveProps";
}
function isComponentWillUnmount(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentWillUnmount";
}
function isComponentWillUpdate(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "componentWillUpdate";
}
function isGetChildContext(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getChildContext";
}
function isGetDefaultProps(node) {
  return AST8__namespace.isMethodOrProperty(node) && node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getDefaultProps";
}
function isGetInitialState(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getInitialState";
}
function isGetSnapshotBeforeUpdate(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getSnapshotBeforeUpdate";
}
function isShouldComponentUpdate(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "shouldComponentUpdate";
}
function isUnsafeComponentWillMount(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "UNSAFE_componentWillMount";
}
function isUnsafeComponentWillReceiveProps(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "UNSAFE_componentWillReceiveProps";
}
function isUnsafeComponentWillUpdate(node) {
  return AST8__namespace.isMethodOrProperty(node) && !node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "UNSAFE_componentWillUpdate";
}
function isGetDerivedStateFromProps(node) {
  return AST8__namespace.isMethodOrProperty(node) && node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getDerivedStateFromProps";
}
function isGetDerivedStateFromError(node) {
  return AST8__namespace.isMethodOrProperty(node) && node.static && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "getDerivedStateFromError";
}
function isRenderLike(node) {
  return AST8__namespace.isMethodOrProperty(node) && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name === "render" && node.parent.parent.type === types.AST_NODE_TYPES.ClassDeclaration;
}
function isFunctionOfRender(node) {
  if (!isRenderLike(node.parent)) {
    return false;
  }
  return isClassComponent(node.parent.parent.parent);
}
function isRenderMethodLike(node) {
  return AST8__namespace.isMethodOrProperty(node) && node.key.type === types.AST_NODE_TYPES.Identifier && node.key.name.startsWith("render") && node.parent.parent.type === types.AST_NODE_TYPES.ClassDeclaration;
}

// src/component/component-hierarchy.ts
function isChildrenOfCreateElement(context, node) {
  const parent = node.parent;
  if (parent == null || parent.type !== types.AST_NODE_TYPES.CallExpression) return false;
  if (!isCreateElementCall(context, parent)) return false;
  return parent.arguments.slice(2).some((arg) => arg === node);
}
function isInsideRenderMethod(node) {
  return AST8__namespace.findParentNode(node, (n) => isRenderLike(n) && isClassComponent(n.parent.parent)) != null;
}
function isFunctionOfComponentDidMount(node) {
  return AST8__namespace.isFunction(node) && isComponentDidMount(node.parent) && node.parent.value === node;
}
function isFunctionOfComponentWillUnmount(node) {
  return AST8__namespace.isFunction(node) && isComponentWillUnmount(node.parent) && node.parent.value === node;
}
function isFunctionOfRenderMethod(node) {
  if (!isRenderMethodLike(node.parent)) {
    return false;
  }
  return isClassComponent(node.parent.parent.parent);
}

// src/component/component-definition.ts
var isFunctionOfClassMethod = tsPattern.isMatching({
  type: tsPattern.P.union(types.AST_NODE_TYPES.ArrowFunctionExpression, types.AST_NODE_TYPES.FunctionExpression),
  parent: types.AST_NODE_TYPES.MethodDefinition
});
var isFunctionOfClassProperty = tsPattern.isMatching({
  type: tsPattern.P.union(types.AST_NODE_TYPES.ArrowFunctionExpression, types.AST_NODE_TYPES.FunctionExpression),
  parent: types.AST_NODE_TYPES.Property
});
var isFunctionOfObjectMethod = tsPattern.isMatching({
  type: tsPattern.P.union(types.AST_NODE_TYPES.ArrowFunctionExpression, types.AST_NODE_TYPES.FunctionExpression),
  parent: {
    type: types.AST_NODE_TYPES.Property,
    parent: {
      type: types.AST_NODE_TYPES.ObjectExpression
    }
  }
});
function isValidComponentDefinition(context, node, hint) {
  if (isChildrenOfCreateElement(context, node) || isFunctionOfRenderMethod(node)) {
    return false;
  }
  if (hint & ComponentDetectionHint.SkipObjectMethod && isFunctionOfObjectMethod(node.parent)) {
    return false;
  }
  if (hint & ComponentDetectionHint.SkipClassMethod && isFunctionOfClassMethod(node.parent)) {
    return false;
  }
  if (hint & ComponentDetectionHint.SkipClassProperty && isFunctionOfClassProperty(node.parent)) {
    return false;
  }
  if (hint & ComponentDetectionHint.SkipArrayMapArgument && AST8__namespace.isArrayMapCall(node.parent)) {
    return false;
  }
  const significantParent = AST8__namespace.findParentNode(
    node,
    AST8__namespace.isOneOf([
      types.AST_NODE_TYPES.JSXExpressionContainer,
      types.AST_NODE_TYPES.ArrowFunctionExpression,
      types.AST_NODE_TYPES.FunctionExpression,
      types.AST_NODE_TYPES.Property,
      types.AST_NODE_TYPES.ClassBody
    ])
  );
  return significantParent == null || significantParent.type !== types.AST_NODE_TYPES.JSXExpressionContainer;
}
function isComponentWrapperCall(context, node) {
  if (node.type !== types.AST_NODE_TYPES.CallExpression) return false;
  return isMemoCall(context, node) || isForwardRefCall(context, node);
}
function isComponentWrapperCallLoose(context, node) {
  if (node.type !== types.AST_NODE_TYPES.CallExpression) return false;
  return isComponentWrapperCall(context, node) || isUseCallbackCall(context, node);
}

// src/component/component-id.ts
function getFunctionComponentId(context, node) {
  const functionId = AST8__namespace.getFunctionIdentifier(node);
  if (functionId != null) {
    return functionId;
  }
  const { parent } = node;
  if (parent.type === types.AST_NODE_TYPES.CallExpression && isComponentWrapperCallLoose(context, parent) && parent.parent.type === types.AST_NODE_TYPES.VariableDeclarator && parent.parent.id.type === types.AST_NODE_TYPES.Identifier) {
    return parent.parent.id;
  }
  if (parent.type === types.AST_NODE_TYPES.CallExpression && isComponentWrapperCallLoose(context, parent) && parent.parent.type === types.AST_NODE_TYPES.CallExpression && isComponentWrapperCallLoose(context, parent.parent) && parent.parent.parent.type === types.AST_NODE_TYPES.VariableDeclarator && parent.parent.parent.id.type === types.AST_NODE_TYPES.Identifier) {
    return parent.parent.parent.id;
  }
  return eff._;
}

// src/component/component-flag.ts
var ComponentFlag = {
  None: 0n,
  PureComponent: 1n << 0n,
  CreateElement: 1n << 1n,
  Memo: 1n << 2n,
  ForwardRef: 1n << 3n,
  Async: 1n << 4n
};

// src/component/component-init-path.ts
function getComponentFlagFromInitPath(initPath) {
  let flag = ComponentFlag.None;
  if (initPath != null && AST8__namespace.hasCallInFunctionInitPath("memo", initPath)) {
    flag |= ComponentFlag.Memo;
  }
  if (initPath != null && AST8__namespace.hasCallInFunctionInitPath("forwardRef", initPath)) {
    flag |= ComponentFlag.ForwardRef;
  }
  return flag;
}
function isComponentName(name) {
  return kit.RE.COMPONENT_NAME.test(name);
}
function isComponentNameLoose(name) {
  return kit.RE.COMPONENT_NAME_LOOSE.test(name);
}
function getComponentNameFromId(id) {
  if (id == null) return eff._;
  return Array.isArray(id) ? id.map((n) => n.name).join(".") : id.name;
}
function hasNoneOrLooseComponentName(context, fn) {
  const id = getFunctionComponentId(context, fn);
  if (id == null) return true;
  const name = Array.isArray(id) ? id.at(-1)?.name : id.name;
  return name != null && isComponentNameLoose(name);
}

// src/component/component-collector.ts
function useComponentCollector(context, options = {}) {
  const {
    collectDisplayName = false,
    collectHookCalls = false,
    hint = DEFAULT_COMPONENT_DETECTION_HINT
  } = options;
  const components = /* @__PURE__ */ new Map();
  const functionEntries = [];
  const getCurrentEntry = () => functionEntries.at(-1);
  const onFunctionEnter = (node) => {
    const key = shared.getId();
    functionEntries.push({ key, node, hookCalls: [], isComponent: false });
  };
  const onFunctionExit = () => {
    const entry = functionEntries.at(-1);
    if (entry == null) return;
    if (!entry.isComponent) return functionEntries.pop();
    const shouldDrop = AST8__namespace.getNestedReturnStatements(entry.node.body).slice().reverse().some((r) => {
      return context.sourceCode.getScope(r).block === entry.node && r.argument != null && !isJsxLike(context.sourceCode, r.argument, hint);
    });
    if (shouldDrop) {
      components.delete(entry.key);
    }
    return functionEntries.pop();
  };
  const ctx = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    getAllComponents(node) {
      return components;
    },
    getCurrentEntries() {
      return [...functionEntries];
    },
    getCurrentEntry
  };
  const listeners = {
    ":function[type]": onFunctionEnter,
    ":function[type]:exit": onFunctionExit,
    "ArrowFunctionExpression[body.type!='BlockStatement']"() {
      const entry = getCurrentEntry();
      if (entry == null) return;
      const { body } = entry.node;
      const isComponent = hasNoneOrLooseComponentName(context, entry.node) && isJsxLike(context.sourceCode, body, hint) && isValidComponentDefinition(context, entry.node, hint);
      if (!isComponent) return;
      const initPath = AST8__namespace.getFunctionInitPath(entry.node);
      const id = getFunctionComponentId(context, entry.node);
      const name = getComponentNameFromId(id);
      const key = shared.getId();
      components.set(key, {
        id,
        key,
        kind: "function",
        name,
        node: entry.node,
        displayName: eff._,
        flag: getComponentFlagFromInitPath(initPath),
        hint,
        hookCalls: entry.hookCalls,
        initPath
      });
    },
    ...collectDisplayName ? {
      [kit.SEL.DISPLAY_NAME_ASSIGNMENT_EXPRESSION](node) {
        const { left, right } = node;
        if (left.type !== types.AST_NODE_TYPES.MemberExpression) return;
        const componentName = left.object.type === types.AST_NODE_TYPES.Identifier ? left.object.name : eff._;
        const component = [...components.values()].findLast(({ name }) => name != null && name === componentName);
        if (component == null) return;
        component.displayName = right;
      }
    } : {},
    ...collectHookCalls ? {
      "CallExpression[type]:exit"(node) {
        if (!isReactHookCall(node)) return;
        const entry = getCurrentEntry();
        if (entry == null) return;
        entry.hookCalls.push(node);
      }
    } : {},
    "ReturnStatement[type]"(node) {
      const entry = getCurrentEntry();
      if (entry == null) return;
      const isComponent = hasNoneOrLooseComponentName(context, entry.node) && isJsxLike(context.sourceCode, node.argument, hint) && isValidComponentDefinition(context, entry.node, hint);
      if (!isComponent) return;
      entry.isComponent = true;
      const initPath = AST8__namespace.getFunctionInitPath(entry.node);
      const id = getFunctionComponentId(context, entry.node);
      const name = getComponentNameFromId(id);
      components.set(entry.key, {
        id,
        key: entry.key,
        kind: "function",
        name,
        node: entry.node,
        displayName: eff._,
        flag: getComponentFlagFromInitPath(initPath),
        hint,
        hookCalls: entry.hookCalls,
        initPath
      });
    }
  };
  return { ctx, listeners };
}
function useComponentCollectorLegacy() {
  const components = /* @__PURE__ */ new Map();
  const ctx = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    getAllComponents(node) {
      return components;
    }
  };
  const collect = (node) => {
    if (!isClassComponent(node)) {
      return;
    }
    const id = AST8__namespace.getClassIdentifier(node);
    const key = shared.getId();
    const flag = isPureComponent(node) ? ComponentFlag.PureComponent : ComponentFlag.None;
    components.set(
      key,
      {
        id,
        key,
        kind: "class",
        name: id?.name,
        node,
        // TODO: Get displayName of class component
        displayName: eff._,
        flag,
        hint: 0n,
        // TODO: Get methods of class component
        methods: []
      }
    );
  };
  const listeners = {
    "ClassDeclaration[type]": collect,
    "ClassExpression[type]": collect
  };
  return { ctx, listeners };
}
var ComponentPhaseRelevance = birecord__default.default({
  mount: "unmount",
  setup: "cleanup"
});
var isInversePhase = eff.dual(2, (a, b) => ComponentPhaseRelevance.get(a) === b);
function isRenderFunctionLoose(context, node) {
  const { body, parent } = node;
  if (AST8__namespace.getFunctionIdentifier(node)?.name.startsWith("render")) {
    return parent.type === types.AST_NODE_TYPES.JSXExpressionContainer && parent.parent.type === types.AST_NODE_TYPES.JSXAttribute && parent.parent.name.type === types.AST_NODE_TYPES.JSXIdentifier && parent.parent.name.name.startsWith("render");
  }
  return isJsxLike(
    context.sourceCode,
    body,
    JSXDetectionHint.SkipNullLiteral | JSXDetectionHint.SkipUndefined | JSXDetectionHint.StrictLogical | JSXDetectionHint.StrictConditional
  );
}
function isRenderPropLoose(context, node) {
  if (node.name.type !== types.AST_NODE_TYPES.JSXIdentifier) {
    return false;
  }
  return node.name.name.startsWith("render") && node.value?.type === types.AST_NODE_TYPES.JSXExpressionContainer && AST8__namespace.isFunction(node.value.expression) && isRenderFunctionLoose(context, node.value.expression);
}
function isDirectValueOfRenderPropertyLoose(node) {
  const matching = (node2) => {
    return node2.type === types.AST_NODE_TYPES.Property && node2.key.type === types.AST_NODE_TYPES.Identifier && node2.key.name.startsWith("render");
  };
  return matching(node) || node.parent != null && matching(node.parent);
}
function isDeclaredInRenderPropLoose(node) {
  if (isDirectValueOfRenderPropertyLoose(node)) {
    return true;
  }
  const parent = AST8__namespace.findParentNode(node, AST8__namespace.is(types.AST_NODE_TYPES.JSXExpressionContainer))?.parent;
  if (parent?.type !== types.AST_NODE_TYPES.JSXAttribute) {
    return false;
  }
  return parent.name.type === types.AST_NODE_TYPES.JSXIdentifier && parent.name.name.startsWith("render");
}
function isThisSetState(node) {
  const { callee } = node;
  return callee.type === types.AST_NODE_TYPES.MemberExpression && AST8__namespace.isThisExpression(callee.object) && callee.property.type === types.AST_NODE_TYPES.Identifier && callee.property.name === "setState";
}
function isAssignmentToThisState(node) {
  const { left } = node;
  return left.type === types.AST_NODE_TYPES.MemberExpression && AST8__namespace.isThisExpression(left.object) && AST8__namespace.getPropertyName(left.property) === "state";
}

exports.ComponentDetectionHint = ComponentDetectionHint;
exports.ComponentFlag = ComponentFlag;
exports.ComponentPhaseRelevance = ComponentPhaseRelevance;
exports.DEFAULT_COMPONENT_DETECTION_HINT = DEFAULT_COMPONENT_DETECTION_HINT;
exports.DEFAULT_JSX_DETECTION_HINT = DEFAULT_JSX_DETECTION_HINT;
exports.JSXDetectionHint = JSXDetectionHint;
exports.findParentAttribute = findParentAttribute;
exports.getAttribute = getAttribute;
exports.getAttributeName = getAttributeName;
exports.getAttributeValue = getAttributeValue;
exports.getComponentFlagFromInitPath = getComponentFlagFromInitPath;
exports.getComponentNameFromId = getComponentNameFromId;
exports.getElementType = getElementType;
exports.getFunctionComponentId = getFunctionComponentId;
exports.getInstanceId = getInstanceId;
exports.hasAnyAttribute = hasAnyAttribute;
exports.hasAttribute = hasAttribute;
exports.hasEveryAttribute = hasEveryAttribute;
exports.hasNoneOrLooseComponentName = hasNoneOrLooseComponentName;
exports.isAssignmentToThisState = isAssignmentToThisState;
exports.isCallFromReact = isCallFromReact;
exports.isCallFromReactObject = isCallFromReactObject;
exports.isCaptureOwnerStack = isCaptureOwnerStack;
exports.isCaptureOwnerStackCall = isCaptureOwnerStackCall;
exports.isChildrenCount = isChildrenCount;
exports.isChildrenCountCall = isChildrenCountCall;
exports.isChildrenForEach = isChildrenForEach;
exports.isChildrenForEachCall = isChildrenForEachCall;
exports.isChildrenMap = isChildrenMap;
exports.isChildrenMapCall = isChildrenMapCall;
exports.isChildrenOfCreateElement = isChildrenOfCreateElement;
exports.isChildrenOnly = isChildrenOnly;
exports.isChildrenOnlyCall = isChildrenOnlyCall;
exports.isChildrenToArray = isChildrenToArray;
exports.isChildrenToArrayCall = isChildrenToArrayCall;
exports.isClassComponent = isClassComponent;
exports.isCloneElement = isCloneElement;
exports.isCloneElementCall = isCloneElementCall;
exports.isComponentDidCatch = isComponentDidCatch;
exports.isComponentDidMount = isComponentDidMount;
exports.isComponentDidUpdate = isComponentDidUpdate;
exports.isComponentName = isComponentName;
exports.isComponentNameLoose = isComponentNameLoose;
exports.isComponentWillMount = isComponentWillMount;
exports.isComponentWillReceiveProps = isComponentWillReceiveProps;
exports.isComponentWillUnmount = isComponentWillUnmount;
exports.isComponentWillUpdate = isComponentWillUpdate;
exports.isComponentWrapperCall = isComponentWrapperCall;
exports.isComponentWrapperCallLoose = isComponentWrapperCallLoose;
exports.isCreateContext = isCreateContext;
exports.isCreateContextCall = isCreateContextCall;
exports.isCreateElement = isCreateElement;
exports.isCreateElementCall = isCreateElementCall;
exports.isCreateRef = isCreateRef;
exports.isCreateRefCall = isCreateRefCall;
exports.isDeclaredInRenderPropLoose = isDeclaredInRenderPropLoose;
exports.isDirectValueOfRenderPropertyLoose = isDirectValueOfRenderPropertyLoose;
exports.isForwardRef = isForwardRef;
exports.isForwardRefCall = isForwardRefCall;
exports.isFragmentElement = isFragmentElement;
exports.isFromReact = isFromReact;
exports.isFromReactLoose = isFromReactLoose;
exports.isFromReactObject = isFromReactObject;
exports.isFromReactStrict = isFromReactStrict;
exports.isFunctionOfComponentDidMount = isFunctionOfComponentDidMount;
exports.isFunctionOfComponentWillUnmount = isFunctionOfComponentWillUnmount;
exports.isFunctionOfRender = isFunctionOfRender;
exports.isFunctionOfRenderMethod = isFunctionOfRenderMethod;
exports.isFunctionOfUseEffectCleanup = isFunctionOfUseEffectCleanup;
exports.isFunctionOfUseEffectSetup = isFunctionOfUseEffectSetup;
exports.isGetChildContext = isGetChildContext;
exports.isGetDefaultProps = isGetDefaultProps;
exports.isGetDerivedStateFromError = isGetDerivedStateFromError;
exports.isGetDerivedStateFromProps = isGetDerivedStateFromProps;
exports.isGetInitialState = isGetInitialState;
exports.isGetSnapshotBeforeUpdate = isGetSnapshotBeforeUpdate;
exports.isHostElement = isHostElement;
exports.isInitializedFromReact = isInitializedFromReact;
exports.isInsideRenderMethod = isInsideRenderMethod;
exports.isInstanceIdEqual = isInstanceIdEqual;
exports.isInversePhase = isInversePhase;
exports.isJsxLike = isJsxLike;
exports.isJsxText = isJsxText;
exports.isKeyedElement = isKeyedElement;
exports.isLazy = isLazy;
exports.isLazyCall = isLazyCall;
exports.isMemo = isMemo;
exports.isMemoCall = isMemoCall;
exports.isPureComponent = isPureComponent;
exports.isReactAPI = isReactAPI;
exports.isReactAPICall = isReactAPICall;
exports.isReactHook = isReactHook;
exports.isReactHookCall = isReactHookCall;
exports.isReactHookCallWithName = isReactHookCallWithName;
exports.isReactHookCallWithNameAlias = isReactHookCallWithNameAlias;
exports.isReactHookCallWithNameLoose = isReactHookCallWithNameLoose;
exports.isReactHookName = isReactHookName;
exports.isRenderFunctionLoose = isRenderFunctionLoose;
exports.isRenderLike = isRenderLike;
exports.isRenderMethodLike = isRenderMethodLike;
exports.isRenderPropLoose = isRenderPropLoose;
exports.isShouldComponentUpdate = isShouldComponentUpdate;
exports.isThisSetState = isThisSetState;
exports.isUnsafeComponentWillMount = isUnsafeComponentWillMount;
exports.isUnsafeComponentWillReceiveProps = isUnsafeComponentWillReceiveProps;
exports.isUnsafeComponentWillUpdate = isUnsafeComponentWillUpdate;
exports.isUseActionStateCall = isUseActionStateCall;
exports.isUseCall = isUseCall;
exports.isUseCallbackCall = isUseCallbackCall;
exports.isUseContextCall = isUseContextCall;
exports.isUseDebugValueCall = isUseDebugValueCall;
exports.isUseDeferredValueCall = isUseDeferredValueCall;
exports.isUseEffectCall = isUseEffectCall;
exports.isUseEffectCallLoose = isUseEffectCallLoose;
exports.isUseFormStatusCall = isUseFormStatusCall;
exports.isUseIdCall = isUseIdCall;
exports.isUseImperativeHandleCall = isUseImperativeHandleCall;
exports.isUseInsertionEffectCall = isUseInsertionEffectCall;
exports.isUseLayoutEffectCall = isUseLayoutEffectCall;
exports.isUseMemoCall = isUseMemoCall;
exports.isUseOptimisticCall = isUseOptimisticCall;
exports.isUseReducerCall = isUseReducerCall;
exports.isUseRefCall = isUseRefCall;
exports.isUseStateCall = isUseStateCall;
exports.isUseSyncExternalStoreCall = isUseSyncExternalStoreCall;
exports.isUseTransitionCall = isUseTransitionCall;
exports.isValidComponentDefinition = isValidComponentDefinition;
exports.stringifyJsx = stringifyJsx;
exports.useComponentCollector = useComponentCollector;
exports.useComponentCollectorLegacy = useComponentCollectorLegacy;
exports.useHookCollector = useHookCollector;
